/*  TODO
    8.  ?Reverse image for CCross sideways card
    9.  ???Add "save" functionality
*/

var months=new Array("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");

function showMeaning (cardtext) {
    popupText.data=cardtext;
    popup.visible=true;
}

function hideMeaning () {
    popup.visible=false;
}

function doReading (spread,query) {
    var picked;
    var removed;
    var tableObject;
    var root = mainWindow.root;
    var position = new Array();
    var cardObject;
    var deck = new Array();
    var now = new Date();
    var cardText;

    
    //Hide any previous reading
    popup.visible=false;
    for (i=0;i<root.subviews.length;i++) {
        if (root.subviews[i].name.search(/layout/) != -1) {
            root.subviews[i].visible=false;
        }
        if (root.subviews[i].name == "layout"+spread) {
            tableObject=root.subviews[i];
        }
    }
    
    //Generate a deck of cards to pick from
    for (j=0;j<=77;j++) {
        deck[j]=j;
    }
    
    //Get meanings of each position of layout
    position = spreadDescriptions[spread].split('#');
    
    //Pick cards, draw them, and add tooltips
    for (k=0;k<spreadCards[spread];k++) {
        print ("Pick number "+k+" from "+deck.length+" cards");
        cardObject=tableObject.subviews[k];
        picked=Math.floor(random(0,deck.length));
        card=deck[picked];
        removed=deck.splice(picked,1);
        reversed=Math.floor(random(0,2));
        cardObject.src="Images/cards/"+card+".jpg";
/* When card is "reversed," we use a different card description, 
   and portray it upside-down via image rotation.  
   Rotation happens around top/left corner... so rotating 180 puts it
   above and to left of where we expect it 
   (so we also adjust the offsets.) 
*/
        cardObject.tooltip="click for meaning";
        if (reversed==0) {
            //cardObject.tooltip=position[k]+"\n\n"+meaningUpright[card];
            cardText='showMeaning("'+position[k]+"\\n\\n"+meaningUpright[card]+'");';
            if (cardObject.rotation == 180) {
                cardObject.rotation = 0;
                cardObject.hOffset -= 54;
                cardObject.vOffset -= 89;
            }
        } else {
            //cardObject.tooltip=position[k]+"\n\n"+meaningReversed[card];
            cardText='showMeaning("'+position[k]+"\\n\\n"+meaningReversed[card]+'");';
            if (cardObject.rotation == 0) {
                cardObject.rotation = 180;
                cardObject.hOffset += 54;
                cardObject.vOffset += 89;
            }
        }
        cardObject.onMouseDown=cardText;
    }
    
    //Display user's query in box at bottom of widget
    queryBox.data=months[now.getMonth()]+" "+now.getDate()+", "+now.getFullYear()+": "+query;
    
    //Show the reading
    tableObject.visible=true;
}
